__doc__ = """Z Photo Slides by JeanFranois Roche (jfroche@jfroche.be)"""
_cvsid = '$Id: ZPhotoSlides.py,v 1.45 2003/02/21 11:11:15 jfroche Exp $'
__version__='$Revision: 1.45 $'[11:-2]
VERSION = '1.0'
DATE = '21/02/03'

from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import HTML
from Globals import package_home
from Globals import MessageDialog # provid
from OFS.Folder import Folder
from OFS.Image  import Image
from AccessControl.Role import RoleManager
from AccessControl import getSecurityManager
from AccessControl import User, Unauthorized
import AccessControl
from Persistence import Persistent
import OFS.SimpleItem
import Acquisition
import AccessControl.Role
import traceback
import os, sys
import math
import time
import random
import string
import shutil
import comment
from stat import stat
import layout
#from Products.PageTemplates import ZopePageTemplate    # i should learn more about this...
from Products.LocalFS import LocalFS
from Products.PythonScripts import PythonScript
from Products.StandardCacheManagers import AcceleratedHTTPCacheManager
from photo_edition.IMG_start import *
from photo_edition.image_modif import Image_modif
from photo_edition.IMG_fileobj import FileObj

try:
	from Products.Localizer import LocalDTMLFile
	from Products.Localizer import Gettext
	gettext = Gettext.translation(globals())
except:
#	print 'no localizer!'
	have_localizer = 0
	from Globals import DTMLFile
	LocalDTMLFile = DTMLFile
	del DTMLFile
else:
	have_localizer = 1

if(not have_localizer):
	from utils import gettext
_ = gettext

def upload_file(path,_prefix=None):
        if _prefix is None: _prefix=SOFTWARE_HOME
        elif type(_prefix) is not type(''):
            _prefix=package_home(_prefix)
        path = os.path.join(_prefix, path)

        file=open(path, 'rb')
        data=file.read()
        file.close()
        return data

def find_tmp_folder():
	tmpdir = ''
	for tmpdir in ('/tmp','c:\windows\Temp','c:\\','c:\winnt\Temp'):
                if(os.path.isdir(tmpdir)):
			result = tmpdir
			break
	return result

manage_addZPhotoSlidesForm = LocalDTMLFile('dtml/ZPhotoSlidesAdd', globals(),gettext=gettext,found_tmp=find_tmp_folder())

MessageDialog2 = HTML(upload_file(os.path.join('dtml','dialog2.dtml'),globals()), target='',action='manage_main', title='Changed',id='id',id_content='',URL1='',gettext=gettext)

def manage_addZPhotoSlides(self, id,photo_folder,thumb_prefix,width,height,tmp_folder,small=0,medium=0,large=0,double_name=1,remove=0,title='',recursive=0,REQUEST=None):
    """Add a ZPhotoSlides to a folder."""
    elapse = time.time()
    c_elapse = time.clock()
    result = ''
    id = string.strip(id)
    if(id == ''):
	raise IOError,"You didn't enter a valid id! ('" + id + "') !!"

    if(not os.path.isdir(photo_folder)):
	false_path = 1
	raise IOError,'Error: %s : folder unknown!!' % photo_folder
    try:
	os.chdir(photo_folder)
    except:
	raise IOError,"Error: The Zope user (often www-data or nobody) can't explore the folder: %s ! \n Please change the rights on this directory! " % (photo_folder)
    if(not os.path.isdir(tmp_folder)):
	raise IOError,'Error: %s : folder unknown!!' % tmp_folder
    try:
	os.chdir(tmp_folder)
    except:
	raise IOError,"Error: The Zope user (often www-data or nobody) can't explore the folder: %s ! \n Please change the rights on this directory! " % (tmp_folder)
    tmpdir = tmp_folder
    position = len(self.objectValues(['ZPhotoSlides Folder','ZPhotoSlides'])) + 1 # position = len(self.objectValues("ZPhotoSlides")) + 1
    img = LocalFS.LocalFS('img','Local Images',photo_folder,username=None,password=None)
    if(not os.path.isdir(os.path.join(tmpdir,'thumb'))): os.mkdir('thumb')
    tmpdir = os.path.join(tmpdir,'thumb')
    tmpwork = LocalFS.LocalFS('tmp','Local Temporary Folder',tmpdir,username=None,password=None)
    self._setObject(id, ZPhotoSlides(id,img,tmpwork,tmpdir,thumb_prefix,position,title))
    ZPS = self._getOb(id)
    ZPS._setObject('img', img)
    ZPS._setObject('tmp', tmpwork)
    ZPS.format_available = ['full']
    ZPS.thumb_width = width
    ZPS.thumb_height = height
    # upload thumbnails
    if(result == None or result == ''):   
	result = ZPS.ask_4_thumbnails(destination=ZPS.thumbnails,prefix=thumb_prefix,width=width,height=height,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
    else:
	result = result + ZPS.ask_4_thumbnails(destination=ZPS.thumbnails,prefix=thumb_prefix,width=width,height=height,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
    ZPS.get_nbr_non_hidden_thumb()
    if(small == 'on'):
	ZPS.manage_addFolder('small',createPublic=0,createUserF=0,REQUEST=None)
	ZPS.ask_4_thumbnails(destination=ZPS.small,prefix=thumb_prefix,width=320,height=320,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
	ZPS.format_available.append('small')
    if(medium == 'on'):
	ZPS.manage_addFolder('medium',createPublic=0,createUserF=0,REQUEST=None)
    	ZPS.ask_4_thumbnails(destination=ZPS.medium,prefix=thumb_prefix,width=480,height=480,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
	ZPS.format_available.append('medium')
    if(large == 'on'):
	ZPS.manage_addFolder('large',createPublic=0,createUserF=0,REQUEST=None)
	ZPS.ask_4_thumbnails(destination=ZPS.large,prefix=thumb_prefix,width=768,height=768,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
	ZPS.format_available.append('large')
    if('medium' in ZPS.format_available):
    	ZPS.default_photo_size = 'medium'
    elif('large' in ZPS.format_available):
	ZPS.default_photo_size = 'large'
    elif('small' in ZPS.format_available):
	ZPS.default_photo_size = 'small'
    else:
	ZPS.default_photo_size = 'full'
    # upload all python scripts
    ZPS.thumbnails.amount_photo = ZPS.get_thumb_amount()
    ZPS._setObject('batch_slides', PythonScript.PythonScript('batch_slides'))
    ZPS.batch_slides.write(upload_file('batch_slides.py',globals()))
    ZPS.list_comment = comment.comments()
    ZPS.new_permission()
    elapse = time.time() - elapse
    c_elapse = time.clock() - c_elapse
    result = result + "<br> <font color=\"green\"><br>Time needed: %s s <br>CPU Time needed: %s s<br></font>" % (elapse,c_elapse)
    return MessageDialog2(
                title = 'ZPhotoSlides Added',
                message1 = result,
                action = 'manage_main',
                id = '',
                id_content = '',
                URL1 = REQUEST.URL1,
                actual_css = ZPS.actual_css
                )

class ZPhotoSlides(
    Folder,
    OFS.SimpleItem.Item,   # A simple Principia object. Not Folderish.
    Persistent,            # Make us persistent. Yaah!
    Acquisition.Implicit,  # Uh, whatever.
    AccessControl.Role.RoleManager # Security manager.
    ):
    "ZPhotoSlides 1.0a"
    access=AccessControl.getSecurityManager()
 
    security = AccessControl.ClassSecurityInfo()
    meta_type = 'ZPhotoSlides' # what do people think they're adding?
    
    if(have_localizer):
    	locale = package_home(globals()) + '/locale/'
    	_gettext = gettext
    	

    manage_options = ( # what management options are there?
#	               {'label': 'Contents',       'action': 'manage_main'},
	               {'label': "Properties", 'action': 'manage_props'},
		       {'label': "View",       'action': 'index_html'}, # defaults to index_html
		       {'label': "Edit layout", 'action': 'user_layout'},
                       {'label': "List all files & Edit Photo", 'action': 'list_files'},
		       {'label': 'Add photos', 'action':'add_photo'},
                       {'label': "Make thumbnails", 'action': 'make_thumb'},
		       {'label': "Manage thumbnails", 'action': 'change_title'},
		       {'label': "Statistics",'action':'stat_zphoto'},
		       {'label': "Manage comments",'action': 'manage_comment'},
		       {'label': "Choose symbolic photo",'action': 'choose_symbolic_pic'},
	               {'label': "Security",   'action': 'manage_access'},
		       {'label': "About this product",   'action': 'about'}
		     )

    __ac_permissions__=( # what permissions make sense for us?
		         ('View management screens', ('manage_tabs','manage_main')),
			 ('Change permissions',      ('manage_access',)           ),
		         ('Change ZPhotoSlides'     ,     ('manage_edit',)             ),
		       )

    # html & dtml files
    manage_tabs = LocalDTMLFile('dtml/manage_tabs',globals(),gettext=gettext)
    index_html = LocalDTMLFile('dtml/index_html',globals(),gettext=gettext)
    getcomment = LocalDTMLFile('dtml/getcomment',globals(),gettext=gettext)
    slide_show = LocalDTMLFile('dtml/slide_show',globals(),gettext=gettext)
    view_photo = LocalDTMLFile('dtml/view_photo',globals(),gettext=gettext) 
    list_files = LocalDTMLFile('dtml/List_files',globals(),gettext=gettext)
    manage_props = LocalDTMLFile('dtml/ZPhotoSlidesEdit', globals(),gettext=gettext) # Management Interface
    make_thumb = LocalDTMLFile('dtml/make_thumb',globals(),gettext=gettext) # form for making the thumb
    edit_image = LocalDTMLFile('dtml/edit_photo',globals(),gettext=gettext)
    change_title = LocalDTMLFile('dtml/list_title',globals(),gettext=gettext)
    add_comment = LocalDTMLFile('dtml/add_comment',globals(),gettext=gettext)
    edit_comment = LocalDTMLFile('dtml/edit_comment',globals(),gettext=gettext)
    choose_color = LocalDTMLFile('dtml/choose_color',globals(),gettext=gettext)
    about = LocalDTMLFile('dtml/about',globals(),gettext=gettext)
    define_css = LocalDTMLFile('dtml/define_css',globals(),gettext=gettext)
    user_layout = LocalDTMLFile('dtml/user_layout',globals(),gettext=gettext)
    choose_symbolic_pic = LocalDTMLFile('dtml/choose_symbolic_pic',globals(),gettext=gettext)
    manage_comment = LocalDTMLFile('dtml/manage_comment',globals(),gettext=gettext)
    stat_zphoto = LocalDTMLFile('dtml/stat_zphoto',globals(),gettext=gettext)
    add_photo = LocalDTMLFile('dtml/add_photo',globals(),gettext=gettext)
    css_info = HTMLFile('dtml/stylesheet_demo.css',globals(),gettext=gettext)
    # secure the html
    security.declarePublic('index_html','batch_slides','view_photo','getcomment','viewable_images')
    security.declareProtected('View management screens','img','get_all_css','about','define_css',
			      'user_layout','list_files','change_title','edit_image','make_thumb',
			      'manage_main','manage_props','edit_comment','comment_for_manage','give_all_images')

    def __init__(self, id,img,tmpwork,tmpdir,thumb_prefix,position,title=''):
        """initialise a new instance of ZPhotoSlides"""
	self.id = id                            # id name
        self.version = VERSION                  # zphotslides version
        self.update_date = DATE                 # last update
        self.title = title                      # title of zphotoslides
        self.thumb_prefix = thumb_prefix        # prefix for the thumbnails (default to "tn_")
        self.image_folder = img                 # image source folder on fs
        self.tmp_dir = tmpdir                   # temp folder on fs
	self.position = position
	self.visits_log = stat()
	self.manage_addImage('bar.gif',upload_file('www/mainbar.gif',globals()))
        self.layout_list = layout.give_list()   # list of the css options
        self.manage_addFolder('thumbnails', 'Thumbnails', createPublic=0,createUserF=0, REQUEST=None) # thumbnails in zodb
        self.manage_addFolder('css', 'Thumbnails', createPublic=0,createUserF=0, REQUEST=None)   # css files in zodb
        self.css._setProperty('amount_css',1,'int')
        self.css.manage_addDTMLMethod('stylesheet_base_css', 'Main ZPhotoSlides Stylesheet', upload_file('dtml/stylesheet.css', globals()), REQUEST=None)
        self.actual_css = 'stylesheet_base_css' # main stylesheet
        self.thumbnails._setProperty('amount_photo',self.get_thumb_amount(),'int')
        self.non_hidden_pic = 0                 # amount of photos not hidden and visible for normal user
        self.list_non_hidden_pic = []           # list of the photos not hidden and visible for normal user
        self.rows = 3                           # default amount of row for layout in rendering the main table of photos
        self.column = 3                         # default amount of colum for layout in rendering the main table of photos
        self.zphoto_header= ''                  # get content of standard header
        self.list_photo = {}                    # list of all the photos
        self.zphoto_footer= ''                  # get content of standard footer
        self.symbolic_photo = ''                # name of the selected symbolic photo
        self.keywords = ''                      # keywords describing the object
        self.description = ''                   # description of the object
        self.first_big = 0                      # default size for slide show
        self.show_comment = 1                   # bool to print or not the comments
        self.show_automatic_slide_show = 1      # bool to print or not the slideshow
        self.show_viewed = 1                    # bool to print or not the amount of visitors for a photo
	self.show_exif = 1		# show the exif infos!
	self.photo_space = 80			# space between the photos in index_html

    def check_tmp_folder(self):
	if(not os.path.isdir(self.tmp_dir)):
		try:
			os.mkdir(self.tmp_dir)
		except:
			assert (IOError,_("Can't create temporary thumb folder in ") + self.tmp_dir)
	try:
		os.chdir(self.tmp_dir)
	except:
		raise (IOError,_("Error: The Zope user (often www-data or nobody) can't explore the folder:") + self.tmp_dir +_("!\n Please change the rights on this directory!"))
        if(not os.access(self.tmp_dir,os.W_OK)):
                raise (IOError,_("Error: Zope user (often www-data, www or nobody) can't write in directory") + self.tmp_dir + _("!! Please change the rights on this directory"))
        if(not os.access(self.tmp_dir,os.R_OK)):
                raise (IOError,_("Error: Zope user (often www-data, www or nobody) can't read in directory") + self.tmp_dir + _("!! Please change the rights on this directory"))
	self.remove_thumbnails_from_disk()
	
    def visited(self,REQUEST):
	self.visits_log.new_visit(REQUEST.REMOTE_ADDR,REQUEST)
	
    def get_exif_infos(self,photo_id):
	try:
		res = self.list_photo[photo_id + '_info']
	except:
		res = {}
	return res

    def needupgrade(self):
	if(self.version in ['0.8','0.9']):
		return 1
	else:
		return 0	

    def upgrade(self,REQUEST=None):
	"Allow the user to upgrade object created in former versions"
	self.position = len(self.aq_parent.objectValues(['ZPhotoSlides','ZPhotoSlides Folder'])) + 1
	if(self.version == '0.8'):
		if(have_localizer):
        		locale = package_home(globals()) + '/locale/'
		        _gettext = gettext
		self.version = '0.9' # seems we don't have anything to modify except this
	if(self.version == '0.9'):
		# add keyword properties for each photos
		for img in self.thumbnails.objectValues():
			try:
				img._setProperty('keywords',[],'tokens')
			except:
				pass
		self.format_available = ['full']
		self.position = len(self.aq_parent.objectValues(['ZPhotoSlides','ZPhotoSlides Folder'])) + 1
		self.default_photo_size = 'full'
		self.thumb_width = 200
		self.thumb_height = 200
		self.visits_log = stat()
		self.show_exif = 1
		self.manage_addImage('bar.gif',upload_file('www/mainbar.gif',globals()))
		self.version = '1.0'
	#self.visits_log = stat()
	if(REQUEST!=None):
		return self.manage_props(REQUEST,manage_tabs_message='ZPhotoSlides Upgraded !')
    def new_permission(self):
	"define new permission"
	self.manage_permission('Upload local files',('Manager','Owner'),acquire=0)
	
    security.declarePublic('use_comment')
    def use_comment(self,id_photo,name,commt,place,email,REQUEST):
	"add a new comment for id_photo"
	times = time.strftime('%H:%M:%S %d-%m-%Y', time.localtime()) # when the comment is add
        self.list_comment.add_new(id_photo,commt,name,place,times,REQUEST.REMOTE_ADDR,email)
	REQUEST.set('photoid',id_photo)
        if REQUEST is not None:
		return self.view_photo(REQUEST=REQUEST)
                
    security.declareProtected('View management screens','choose_symbolic_photo')
    def choose_symbolic_photo(self,photo_name=None,REQUEST=None):
	"Choose the symbolic photo for the ZPhotoSlides Folder"
	if(photo_name != None):
		self.symbolic_photo = photo_name
		comment = _('Change of symbolic photo sucessful! <br> Symbolic photo is now:') + photo_name
	else:
		comment = _('You forgot to choose a photo!')
	
	if REQUEST is not None:
		return self.choose_symbolic_pic(manage_tabs_message=comment)
    def has_comment(self,id_photo):
	"Has a comment for the photo"
	for elem in self.list_comment:
		if(elem.id==id_photo):
			return 1
	return 0

    security.declarePublic('get_comment')    
    def get_comment(self,id_photo):
	"Print the comments for a photo"
        liste_dict = []                              # new list
        for elem in self.list_comment:               # for all comments
            if(elem.id==id_photo):                   #   if comment for the photo
                    dict= {}                         #       we add the comment to the list
                    dict['comment'] =elem.commt
                    dict['user'] = elem.user
                    dict['place'] = elem.place
                    dict['date'] = elem.date
                    dict['ip'] = elem.ip
                    dict['email'] = elem.email
                    liste_dict.append(dict)
        return liste_dict                               # we return the list

    security.declareProtected('View management screens','delete_comment')
    def delete_comment(self,photo_id,comment_date,REQUEST):
	"Delete a comment from a photo fallowing the comment date"
	for comment in self.list_comment:
		if(comment.id==photo_id and comment.date==comment_date):
			self.list_comment.remove(comment)
			break
	if REQUEST is not None:
		return self.manage_comment(manage_tabs_message='Comment deleted for '+ str(photo_id))
    
    security.declareProtected('View management screens','modify_comment')    
    def modify_comment(self,photo_id,old_date,date,name,email,place,commt,REQUEST):
	"Manager modify a comment"
	for comment in self.list_comment:
		if(comment.id==photo_id and comment.date==old_date):
			comment.date = date
			comment.user = name
			comment.email = email
			comment.place = place
			comment.commt = commt
			break
		
	if REQUEST is not None:
		return self.manage_comment(manage_tabs_message='Comment Modified for '+ str(photo_id))

    def get_keywords(self,photo_id):
	string = ''
	for imag in self.thumbnails.objectValues('Image'):
		if(imag.getId()==photo_id):
			cpt = 0
			for elem in imag.keywords:
			   if(cpt == 0):
				string = elem
			   else:
			   	string = string + ', ' + str(elem).strip()
			   cpt= cpt +1
			break
	return string		
    
    def get_nbr_non_hidden_thumb(self):
	"return list of non hidden photos"
	images = self.thumbnails.objectValues('Image')
	nbr= len(images)
	list_thumb = []
	for img in images:
		if(img.__dict__.has_key('getviewit') and img.getviewit=='0'):
			nbr = nbr - 1
		else:
			list_thumb.append(img)
	self.non_hidden_pic = nbr
	self.list_non_hidden_pic = list_thumb
	self.list_non_hidden_pic.sort(lambda x, y: cmp(x.position, y.position))
	return self.list_non_hidden_pic

    def upgrade_old(self):
        "Upgrade from a previous version"
	if not self.__dict__.has_key("format_available"):
		self.format_available = [ "full" ]

	if not self.__dict__.has_key("default_photo_size"):
		self.default_photo_size = "full"

    security.declareProtected('View management screens','add_new_css')
    def add_new_css(self,REQUEST):
	"Add a new CSS file in css folder"
	title=REQUEST.title
	file = REQUEST.file
	id = 'css' + str(self.css.amount_css)
	self.css.manage_addDTMLMethod(id, title, file, REQUEST=None)
	self.css.amount_css = self.css.amount_css + 1
	self.actual_css = id
	if(REQUEST!=None):
		return self.user_layout(manage_tabs_message='Your CSS file has been added !')
    
    security.declareProtected('View management screens','use_uploaded_css')
    def use_uploaded_css(self,REQUEST):
	"Use a css which is in folder css"
	choosed = REQUEST.uploaded_css
	self.actual_css = choosed
	if(REQUEST!=None):
                return self.user_layout(manage_tabs_message='The Css file you choose is now used to define the layout !')

    security.declareProtected('View management screens','change_main_css')
    def change_main_css(self,REQUEST):
	"Change the main css tag for the Main ZPhotoSlides Stylesheet"
	dict = REQUEST.form
	for elem in dict.keys():
	   dic1,dic2 = string.split(elem,'__')
	   self.layout_list[dic1][dic2] = dict[elem]
	self.actual_css = 'stylesheet_base_css'
	if(REQUEST!=None):
		return self.user_layout(manage_tabs_message='Modifications saved for Main ZPhotoSlides Stylesheet!')

    def give_header_4_robots(self):
	"give the header for the robots"
	return """
<meta name="KEYWORDS" content="%s" />
<meta name="DESCRIPTION" content="%s" />
<meta name="resource-type" content="document" />
<meta name="ROBOTS" content="INDEX,FOLLOW" />
<meta http-equiv="expires" content="0" />
<meta name="author" content="ZPhotoSlides" />
<meta name="copyright" content="ZPhotoSlides %s" />
<meta name="revisit-after" content="1 days" />
<meta name="rating" content="General" />""" % (self.keywords,self.description,self.version)
    
    security.declareProtected('View management screens','new_header_footer')
    def new_header_footer(self,REQUEST):
	"Change the standard_html_header and footer"
	self.zphoto_header = REQUEST.header
	self.zphoto_footer = REQUEST.footer
	if(REQUEST.header != '' or REQUEST.footer != ''):
                msg1 = _("""You use yet the standard html footer and header. To use the css files again
                make the standard html footer and header <u><i>EMPTY</i></u> in the layout formular!""")
                title_1 = "Using standard html header and footer"
        else:
		msg1 = _("You use yet the CSS file.")
		title_1 = _("Using CSS file")
	if(REQUEST!=None):
		return self.user_layout(manage_tabs_message=msg1)	

    def get_photo_format_available(self,REQUEST):
	result = {}
	if(REQUEST.has_key('ph_size')):
		size = REQUEST.ph_size
	else:
		size = self.default_photo_size

	self.format_available.sort()
	self.format_available.reverse()
	for elem in self.format_available:
		if(elem!=size):
			result[elem] = 'ok'
		else:
			result[elem] = ''
	return result

    def get_list_photo_4_slideshow(self,REQUEST,full):
	"get the list of photos for the Javascript of the slideshow"
	list_string = ''
	cpt = 1
	for elem in self.list_non_hidden_pic:
		dict = {}
		if(full=='1'): # si full -> access au fichier en full
			filename = elem.access.replace(' ','%20')
			url = REQUEST.URL1 + '/img/' + filename
			string1 = 'photo_urls[%d] = "%s";' % (cpt,url)
			string2 = 'photo_captions[%d] = "%s";' % (cpt,elem.title_or_id())
			list_string = list_string + '\n' + string1 + '\n' + string2 + '\n'
		else:
			filename = elem.getId().replace(' ','%20')
			url_small = REQUEST.URL1 + '/thumbnails/' + filename
			string3 = 'photo_urls_small[%d] = "%s";' % (cpt,url_small)
			string2 = 'photo_captions[%d] = "%s";' % (cpt,elem.title_or_id())
			list_string = list_string + '\n' + string2 + '\n' + string3
                
		cpt = cpt + 1
	return list_string[1:]
	    
    def amount_photos(self):
	return len(self.list_non_hidden_pic)
	
    security.declarePublic('photo_visited')   
    def photo_visited(self,thumb_id):
	"""increase the number of visit of a photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	thumb_pic.viewed = int(thumb_pic.viewed) + 1
        return thumb_pic

    def getRandom(self):
	return random.randint(0,100)

    security.declarePublic('img_allow_show')
    def img_allow_show(self,img_name):
#	"return 1 if the image can be show"
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==img_name):
			return int(img.getviewit)
	return 0

    security.declarePublic('getSlide')
    def getSlide(self,thumb_id):
	"""Give the number of the slide where is the photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos= int(thumb_pic.position)
	tmp = (pos)/(self.rows*self.column)
	return tmp

    security.declarePublic('photo_hasPrev')
    def photo_hasPrev(self,thumb_id):
	"""Give the previous photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = int(thumb_pic.position)
	min = 99999999
	min_photo = ''
	for img in self.list_non_hidden_pic:
	    if(img.getId()!=thumb_id and pos > img.position and pos-int(img.position)<min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    security.declarePublic('photo_hasNext')
    def photo_hasNext(self,thumb_id):
	"""Give the next photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = int(thumb_pic.position)
	min = 999999999
	min_photo = ''
	for img in self.list_non_hidden_pic:
	    if(img.getId()!=thumb_id and pos < img.position and int(img.position)-pos < min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    def manage_edit(self, title,show_exif,first_big,keywords,description,photo_space,show_comment,default_photo_size,rows,column,photo_folder,show_automatic_slide_show,show_viewed, REQUEST=None):
	"""does this really need a doc string?"""
	self.title = title
	self.default_photo_size = default_photo_size
	self.show_automatic_slide_show = int(show_automatic_slide_show)
	self.keywords = 'ZPhotoSlides,' + keywords
	self.description = description
	self.photo_space = int(photo_space)
	self.show_exif = int(show_exif)
	result = ''
	if(not os.path.isdir(photo_folder)):
        	result = '<font color="red"><b><u>%s</u> %s : %s</b></font><br>' % (_('Error:'),photo_folder,_('folder unknown'))
	else:
		old_basepath = self.image_folder.basepath
        	self.image_folder.basepath = photo_folder
		if(old_basepath != photo_folder):
                	self.remove_thumbnails()

	self.rows = int(rows)
	self.first_big = int(first_big)
	self.show_viewed = int(show_viewed)
	self.show_comment = int(show_comment)
	self.column = int(column)
        if REQUEST is not None:
		message = _("Properties for") + ' ' +self.id  + ' ' +  _('changed') + ".<br> %s" % (result)
		return self.manage_props(REQUEST,manage_tabs_message=message)

    security.declarePrivate('remove_thumbnails')
    def remove_thumbnails(self):
	for img in self.thumbnails.objectValues('Image'):
		self.thumbnails.manage_delObjects(img.getId())

    security.declareProtected('View management screen','delete_thumbnail')
	
    security.declarePrivate('remove_thumbnails_from_disk')
    def remove_thumbnails_from_disk(self):
	for img in self.tmp.fileValues():
		tmpdir = os.path.join(self.tmp_dir,img.id)
		try:
			os.remove(tmpdir)
		except:
			pass # we dont want to delete folder

    def add_new_photo(self,REQUEST):
	"Add new photos"
	self.remove_thumbnails_from_disk()
	os.chdir(self.tmp_dir)
        if(not os.path.isdir(os.path.join(self.tmp_dir,'new'))): 
		os.mkdir('new')
	else:
		for img in self.tmp.new.fileValues():
			tmpdir = os.path.join(self.tmp_dir,'new')
                	tmpdir = os.path.join(tmpdir,img.id)
                	try:
                        	os.remove(tmpdir)
                	except:
                        	pass # we dont want to delete folder
		
	for elem in REQUEST.form.keys():
		file = REQUEST.form[elem]
		if(file.filename!=''):
			self.tmp.new.manage_upload(file)
			file_loc = os.path.join(self.tmp.basepath,'new')
			file_loc = os.path.join(file_loc,file.filename)
			#os.system('cp %s %s' % (file_loc,self.image_folder.basepath))
			shutil.copyfile(file_loc,os.path.join(self.image_folder.basepath,file.filename))
#			self.image_folder.manage_upload(file)
	olddir = self.image_folder.basepath
	self.image_folder.basepath = os.path.join(self.tmp_dir,'new')
	medium = ''
	small = ''
	large = ''
	if('medium' in self.format_available):
		medium = 'on'
	if('large' in self.format_available):
		large = 'on'
	if('small' in self.format_available):
		small = 'on'
	self.manage_make_thumb('tn_',0,0,0,self.thumb_width,self.thumb_height,None,small,medium,large)
	self.image_folder.basepath = olddir
	return self.add_photo(REQUEST,manage_tabs_message='Photos Added!')

    security.declareProtected('View management screen','manage_make_thumb')
    def manage_make_thumb(self,prefix,recursive,double_name,remove,width,height,REQUEST,small='',medium='',large=''):
	"Make the thumbnails from the make_thumb view"
	self.thumb_width = width
	self.thumb_height = height
         # first we do the thumbnails
        res = self.ask_4_thumbnails(self.thumbnails,prefix,width,height,recursive,double_name,remove,None)
        if(small == 'on'):
		if(not self.__dict__.has_key('small')):
			self.manage_addFolder('small',createPublic=0,createUserF=0,REQUEST=None)
		try:
			self.ask_4_thumbnails(self.small,prefix,320,320,recursive,double_name,remove,None)
		except:
			pass
		else:
			res = res + '<br> Small size created !'
			if('small' not in self.format_available):
				self.format_available.append('small')
	else: # we don't use the small size
		if('small' in self.format_available):
			self.format_available.remove('small')
			res = res + '<br> Small size removed !'
	if(medium == 'on'):
		if(not self.__dict__.has_key('medium')):
			self.manage_addFolder('medium',createPublic=0,createUserF=0,REQUEST=None)
		try:
			res = res + self.ask_4_thumbnails(self.medium,prefix,480,480,recursive,double_name,remove,None)
		except:
			pass
		else:
			res = res + '<br> Medium size created !'
			if('medium' not in self.format_available):
				self.format_available.append('medium')
	else: # we don't use the medium size
		if('medium' in self.format_available):
			self.format_available.remove('medium')
			res = res + '<br> Medium size removed !'
		
	if(large == 'on'):
		if(not self.__dict__.has_key('large')):
			self.manage_addFolder('large',createPublic=0,createUserF=0,REQUEST=None)
		try:
			self.ask_4_thumbnails(self.large,prefix,768,768,recursive,double_name,remove,None)
		except:
			pass
		else:
			res = res + '<br> Large size created !'
			if('large' not in self.format_available):
				self.format_available.append('large')
	else:
		if('large' in self.format_available):
			self.format_available.remove('large')
			res = res + '<br> Large size removed !'
	for elem in ['full','small','large','medium']:
		if(elem in self.format_available):
			self.default_photo_size = elem
	if(REQUEST!=None):		
		return self.make_thumb(REQUEST,manage_tabs_message=res)
	else:
		return res

    security.declareProtected('View management screen','ask_4_thumbnails')
    def ask_4_thumbnails(self,destination,prefix=None,width=200,height=200,recursive=None,double_name=None,remove=0,REQUEST=None):
        """Make the thumbnails   from the path"""
	info = ''
	if prefix == None: prefix = REQUEST.prefix
        if recursive == None: recursive = REQUEST.recursive # -> allow recursive in folder
        if double_name == None: double_name = REQUEST.double_name # able to manage photos with same name in different folder
        remove = int(remove)
	self.check_tmp_folder()
        if(remove):
     		for elem in destination.objectValues():
       			destination.manage_delObjects(elem.getId())
		
	width = int(width)
	height = int(height)
	start_path = self.image_folder.basepath
        try:
		self.new_list_photo,amount = thumbnails_manage(start_path,self.tmp_dir,recursive,double_name,width,height,prefix,{})
        except:
		print traceback.print_exc()
	for elem in self.new_list_photo.keys():
		self.list_photo[elem] = self.new_list_photo[elem]
	infos = '<br>'
	for kei in self.list_photo.keys():
		tmp = self.list_photo[kei]
		if(type(tmp)=='' and tmp.find('Error') != -1):
			infos = infos + '<br>' + tmp
			del self.list_photo[kei]          
	result = ''
	if(self.list_photo != {}):
		result = ('<b>%i</b>'%amount) + ' '  + _('Thumbnails done in folder') + self.tmp_dir
#        if(upload==1):
	dict = {}
	dict,amount = self.upload_thumbnails(destination,prefix)
	result = result + ('<br><b>%i</b>'%amount) + ' ' +  _('Thumbnails uploaded in ZODB')
	if(dict != {}):
		for elem in dict.keys():
			result = result + _('<br><center><b><font color="red">Error in file upload in ZODB: [') + elem + ']:' +  dict[elem] + '</b></font></center>'
	self.remove_thumbnails_from_disk()
	if (infos != '<br>'):
		result = result + _('<br><center><b><font color="red">Error on files while creating thumbnails:') + infos + '</b></font></center>'
	self.get_nbr_non_hidden_thumb()
        if REQUEST is not None:
		return self.make_thumb(manage_tabs_message=result)
        else:
		return result
              
    security.declarePrivate('update_position')
    def update_position(self,new_position,old_position):
	for img in self.thumbnails.objectValues('Image'):
		if(img.position == new_position):
			img.position = old_position
				
    security.declareProtected('View management screen','update_photos_prop')
    def update_photos_prop(self,REQUEST):
        """update properties of the thumbnails"""
	list = []
	for elem in REQUEST.items():
		if elem[0].find('stringbidon') != -1:
			list.append(elem)
	dict = {}
	for elem in list:
		full = elem[0].split('/')
		id = full[1]
		property = full[2]
		value = elem[1]
		for img in self.thumbnails.objectValues('Image'):
	                if(img.getId()==id):
			   if property == 'removeit' and (value == '1'):
 					pos_del = img.position
					self.thumbnails.manage_delObjects(img.getId())
					for img in self.thumbnails.objectValues('Image'):
						if(img.position > pos_del):
							img.position = img.position - 1
			   else:
				   if property == 'keywords':
					keywords = value.split(',')
					list_keywords = []
					for keyword in keywords:
						keyword = keyword.strip()
						if(keyword!=''):
						   list_keywords.append(keyword)
					if(list_keywords != img.keywords):
						img.keywords = list_keywords
				   if property == 'title':
					if(img.title != value):
						img.title = value
				   if property == 'viewit':
					if(img.getviewit != value):
						img.getviewit = value # property has change
				   if property == 'position':
					old_position = img.position
					new_position = int(value)
					if(img.position != new_position):
						self.update_position(new_position,old_position)
						img.position = new_position
	string = ''
	self.get_nbr_non_hidden_thumb()
	self.thumbnails.amount_photo = self.get_thumb_amount()
	string = string[1:]
	result = _('Properties have been updated')
	return self.change_title(self,manage_tabs_message=result)

    def get_img_in_thumbnails(self,img_id,list):
	for elem in list:
		if(elem.getId() == img_id):
			return elem
	return None

    def upload_file(self,tmpdir,cpt,img,destination):
	info = ''
	prop_id = 'getviewit'
	prop2_id = 'position'
	prop3_id = 'viewed'
	prop4_id = 'access' # way to access to the file
	prop5_id = 'way_to_access'
	prop6_id = 'keywords'
	file = open(tmpdir,'rb')
	data = file.read()
	file.close()
	cpt = self.get_thumb_amount()
	type = OFS.Image.getImageInfo(data)
	destination.manage_addImage(img.id,data,content_type=type[0])
	imag = getattr(destination,img.id)
	imag._setProperty(prop2_id.strip(),cpt,'int')
	cpt = cpt + 1
	imag._setProperty(prop5_id.strip(),'filesystem')
	imag._setProperty(prop4_id.strip(),self.list_photo[imag.getId()])
	imag._setProperty(prop_id.strip(), '1')
	imag._setProperty(prop3_id.strip(), 0,'int')
	imag._setProperty(prop6_id.strip(), [],'tokens')
	return cpt
	
    security.declareProtected('View management screen','upload_thumbnails')
    def upload_thumbnails(self,destination,prefix=None):
	"""Upload the thumbnails into the ZODB"""
	info = ''
	dict = {}
	cpt = 0
	if(prefix==None):
		prefix = self.thumb_prefix
	for img in self.tmp.fileValues():
		if(img.id[:len(prefix)]==prefix and img.id[-3:]!='bak'):
			 # take thumbnails and bak files!
			 tmpdir = os.path.join(self.tmp_dir,img.id)
			 start_path = os.path.join(self.image_folder.basepath,img.id)
			 list = destination.objectValues()

			 image = self.get_img_in_thumbnails(img.id,list)
			 #check if the image isn't already in folder
			 if(image == None):
			 	try:
					cpt = self.upload_file(tmpdir,cpt,img,destination)
				except:
					info = _('Error: ')
					for i in sys.exc_info():
						info = info + '   ' + str(i)
					dict[img.id] = info
					print info

			 elif(img.get_size() != image.getSize()):
			 	try:
					destination.manage_delObjects(img.getId())
					cpt = self.upload_file(tmpdir,cpt,img,destination)
				except:
					info = _('Error: ')
					for i in sys.exc_info():
						info = info + '   ' + str(i)
					dict[img.id] = info
					print info
			 else:
			 	info = _('<font color="green"> Seems that the photo already exist in ZODB</font>')
			 	dict[img.id] = info
	list = destination.objectValues()
	if(list != [] and destination == self.thumbnails): #choose the first one for ZPhotoSlides Folder
		self.choose_symbolic_photo(list[0].getId())
	return dict,cpt

    def get_thumb_amount(self):
	return len(self.thumbnails.objectValues('Image'))

    def back_from_form(self,REQUEST):
	text = ''
	for elem in REQUEST.form.keys():
		value = REQUEST.form[elem]
		if(value==''):
		   value='0'
		if(elem!='file'):
		   text = text + '<input type="hidden" name="%s" value="%s">' % (elem,value)
	return text
	
    def view_preview(self,REQUEST):
	"""View the preview of an image"""
	img = self.image_modif(REQUEST,1)
	image = REQUEST.file
	self.check_tmp_folder()
	location = os.path.join(self.tmp_dir,img.imgname)
	img.save_to(location)
	hidden_part = self.back_from_form(REQUEST)
	msg2 = ''
	if(hasattr(REQUEST,'show_both') and REQUEST.show_both=='on'):
		msg2 = _('<table><tr><td class="boxborder"><center><h4>Before modification:</h4></center><br>') + '<img src="%s/img/%s?%d"></td>' % (REQUEST.URL1+'',image,random.randint(0,100))
        else:
                msg2 = ''
	return MessageDialog2(
		        title = _('Preview modification of') + image,
			message1 = _('<td class="boxborder"><center><h4>After modification: </h4></center><br><center>') + '<img src="%s/tmp/%s?%d"></center></td></tr></table>' % (REQUEST.URL1+'',img.imgname,random.randint(0,100)),
			message2 = msg2,
			hidden_field = hidden_part,
	  		action = 'edit_image',
			id = 'file',
			id_content = image,
			URL1 = REQUEST.URL1,
			actual_css = self.actual_css
			)
	
	
    security.declareProtected('View management screen','image_modif')
    def image_modif(self,REQUEST,preview=0):
        """Modify an image """
	image = REQUEST.file
        angle = REQUEST.angle
	path = self.image_folder.basepath
	abspath = path + '/' + image
	img = Image_modif(abspath)
        img.make_backup()
	modif = 0
	img = img.modify_from_request(img,REQUEST)
	if(preview==1):
		return img
	if (modif==0):
		return self.edit_image(file=image,manage_tabs_message=_('Nothing has to be done on image') + image)
	img.save_modif()
	if REQUEST is not None:
		return self.edit_image(file=image,manage_tabs_message= _("Modification done for") + image)
    
    security.declareProtected('View management screen','get_image_info')
    def get_image_info(self,image_name):
	"""Get all the informations about an image"""
	path = self.image_folder.basepath
	abspath = os.path.join(path,image_name)
	img = Image_modif(abspath)
	dict = img.get_info()
	return dict

    security.declareProtected('View management screen','undo_modif')
    def undo_modif(self,REQUEST):
	"""Undo a previous modification of an image"""
	image = REQUEST.file
	bak = image + '.bak'
	path = self.image_folder.basepath
	new = os.path.join(path,image)
	backup = os.path.join(path,bak)
	if os.path.exists(backup):
	    shutil.copyfile(backup,new)
	    os.remove(backup)
	    return self.edit_image(file=image,manage_tabs_message=_("Undo successfull !"))
	else:
	    return self.edit_image(file=image,manage_tabs_message=_("Sorry, undo can't be done for this image."))
                
    def viewable_images(self):
	images = self.thumbnails.objectValues('Image')
	for img in self.thumbnails.objectValues('Image'):
        	if(img.getviewit=='0'):
                	images.remove(img)
	images.sort(lambda x, y: cmp(x.position, y.position))
	return images

