#!/usr/bin/env python

# Jean-Franois Roche (jfroche@jfroche.be)
#  ZPhotoSlides 0.8
#  GNU GPL
# 

from IMG_fileobj import FileObj
from IMG_img import Img
import os, sys
import dircache
import exiftool


def thumbnails(path,init_path,destination='/tmp/paula2',width=200,height=200,prefix='tn_',dict={},double_name=0):
	prefix_size=len(prefix)
	amount = 0
	fo = FileObj(path)
	for i in fo.getBiggerFileList():
		Im = Img(i[0])
		try:
			Im.open_image()
		except:
			errormsg = '\\Error:'
			for i in sys.exc_info(): 
				errormsg = errormsg + '   ' + str(i)
			dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
		else:
			
			if(hasattr(Im,'im')): # if it's a valid image!
				if(Im.imgname[:prefix_size]!=prefix and Im.imgname[-3:]!='bak'):
	# 				dont thumbnailize the thumbnails!!!
					oldname = Im.imgname
					Im.imgname = prefix + Im.imgname
					if(dict.has_key(Im.imgname) and double_name):#if file already in another directory we must rename it!
						if(dict.has_key('cpt__' + Im.imgname)):# cpt exist already?
							dict['cpt__' + Im.imgname ] = dict['cpt__' + Im.imgname] + 1
						else:
							# cpt dont exist yet for this file (first file with the same name)
							dict['cpt__' + Im.imgname] = 0
							filename,extension=os.path.splitext(Im.imgname)
							Im.imgname = filename + str(dict['cpt__' +Im.imgname]) + extension
					 
					dict[Im.imgname] = os.path.join(path,oldname)
					dict[Im.imgname] = dict[Im.imgname][len(init_path)+1:]
					dest = os.path.join(destination,Im.imgname)
					
					try:
						Im.thumbnailize(width,height,prefix,dest)
					except:
						errormsg = '\\Error in thumbnailizing:'
			                        for i in sys.exc_info():
                        		        	errormsg = errormsg + '   ' + str(i)
						dict[Im.imgname] = Im.imgname + ': ' + errormsg + '<br>'
					else:
						if(Im.imgformat == 'JPEG'):
							dict[Im.imgname+'_info'] = exiftool.exif_parse(Im.getimgpath())
						amount = amount + 1
	return dict,amount


def recursive_thumbnails(path,init_path,destination,width=200,height=200,prefix='tn_',dict={},double_name=1,cpt=0):
	dir = path
	dict,amount = thumbnails(path,init_path,destination,width,height,prefix,dict,double_name)
	cpt = cpt + amount
#	print 'Num: (%s)' % dir + str(cpt)
	list = os.listdir(dir)
	for elem in list:
		new_dir = os.path.join(dir,elem)
		if(os.path.isdir(new_dir) and os.access(new_dir,os.R_OK)):
			null, res = recursive_thumbnails(new_dir,init_path,destination,width,height,prefix,dict,double_name,cpt)
			cpt =res
	return dict,cpt

def thumbnails_manage(path,destination='/tmp',recursive=1,double_name=1,width=200,height=200,prefix='tn_',dict={}):
	if(path[-1] == '\\' or path[-1] == '/'):
		path = path[:-1]
	if(recursive):
		dict,amount = recursive_thumbnails(path,path,destination,width,height,prefix,dict,double_name,0)
	else:
		dict,amount = thumbnails(path,path,destination,width,height,prefix,dict,0)
	for elem in dict.keys():
		if(elem[:5]=='cpt__'): # remove count keys
			del dict[elem]
		else:	
			try:
				dict[elem] = dict[elem].replace('\\','/')
			except:
				pass
	return dict,amount
	
if __name__ == '__main__':
	res, nombre = thumbnails_manage('/usr/photo2')
#	MakeJPG(sys.argv[1])
#	
#	MakeThumbnails(sys.argv[1])
#	a=MakeThumbnails()
#	dict= recursive_thumbnails('/tmp/toPaula','/tmp/paula2')
#	dict = thumbnails_manage('/var/zope/images','/tmp',1,1,dict)
#	print dict['cool.txt']
	print 'Num: ' + str(nombre)
